"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var parseObjectLookupString_exports = {};
__export(parseObjectLookupString_exports, {
  default: () => parseObjectLookupString_default,
  parseObjectLookupString: () => parseObjectLookupString
});
module.exports = __toCommonJS(parseObjectLookupString_exports);
var import_code_frame_error = __toESM(require("code-frame-error"));
function parseObjectLookupString(path, { escape = "\\" } = {}) {
  if (escape.length !== 1) {
    throw new Error(`Escape char must have length 1, got ${escape.length}`);
  }
  if (!(path == null ? void 0 : path.trim())) {
    return [];
  }
  const ctx = path.split("").reduce(
    (ctx2, char) => {
      var _a, _b, _c, _d, _e, _f, _g;
      if (((_a = ctx2.state) == null ? void 0 : _a.type) === "escape") {
        if (char === escape || char === ctx2.state.parent.kind) {
          ctx2.state.parent.value += char;
          ctx2.state = ctx2.state.parent;
          return ctx2;
        } else {
          ctx2.state.parent.value += escape;
          ctx2.state = ctx2.state.parent;
        }
      }
      if (char.match(/\r/) && ((_b = ctx2.state) == null ? void 0 : _b.type) !== "string") {
        return ctx2;
      }
      ctx2.column += 1;
      if (char.match(/\n/)) {
        ctx2.line += 1;
        ctx2.column = 1;
        if (((_c = ctx2.state) == null ? void 0 : _c.type) !== "string") {
          return ctx2;
        }
      }
      if (char.match(/\s/) && ((_d = ctx2.state) == null ? void 0 : _d.type) !== "string") {
        return ctx2;
      }
      if (((_e = ctx2.state) == null ? void 0 : _e.type) === "string") {
        if (char === escape) {
          ctx2.state = { type: "escape", parent: ctx2.state };
          return ctx2;
        }
        if (char === ctx2.state.kind) {
          ctx2.token = ctx2.state.value;
          ctx2.state = ctx2.state.parent;
        } else {
          ctx2.state.value += char;
        }
        return ctx2;
      }
      if (((_f = ctx2.state) == null ? void 0 : _f.type) === "dot") {
        ctx2.state = ctx2.state.parent;
        push(ctx2);
      }
      if (((_g = ctx2.state) == null ? void 0 : _g.type) === "access expression") {
        if (char.match(/[0-9]/)) {
          ctx2.token = (ctx2.token || "") + char;
          return ctx2;
        }
        if (!ctx2.token && isStringDelimiter(char)) {
          ctx2.state.with = "string";
          ctx2.state = {
            type: "string",
            parent: ctx2.state,
            value: "",
            kind: char
          };
          return ctx2;
        }
        if (ctx2.token && char === "]") {
          if (ctx2.state.with === "number") {
            ctx2.token = parseInt(ctx2.token, 10);
          }
          push(ctx2);
          return ctx2;
        }
        throw new import_code_frame_error.default(`Unexpected ${char}`, {
          rawLines: path,
          location: { start: { column: ctx2.column, line: ctx2.line } }
        });
      }
      if (char === "?") {
        ctx2.state = { type: "optional", parent: ctx2.state };
        return ctx2;
      }
      if (char === ".") {
        ctx2.state = { type: "dot", parent: ctx2.state };
        return ctx2;
      }
      if (char === "[") {
        if (ctx2.token !== void 0) {
          push(ctx2);
        }
        ctx2.state = {
          type: "access expression",
          parent: ctx2.state,
          with: "number"
        };
        return ctx2;
      }
      if (!ctx2.token && char.match(/[a-zA-Z_$]/)) {
        ctx2.token = char;
        return ctx2;
      }
      if (typeof ctx2.token === "string" && char.match(/[\w_$]/)) {
        ctx2.token += char;
        return ctx2;
      }
      throw new import_code_frame_error.default(`Unexpected ${char}`, {
        rawLines: path,
        location: { start: { column: ctx2.column, line: ctx2.line } }
      });
    },
    {
      path: [],
      column: 1,
      line: 1,
      optional: false
    }
  );
  if (ctx.state) {
    throw new import_code_frame_error.default(`Unterminated ${ctx.state.type}`, {
      rawLines: path,
      location: { start: { column: ctx.column, line: ctx.line } }
    });
  }
  push(ctx);
  return ctx.path;
}
function push(ctx) {
  var _a, _b;
  if (ctx.token !== void 0) {
    ctx.path.push({
      key: ctx.token,
      optional: ctx.optional
    });
  }
  ctx.optional = ((_a = ctx.state) == null ? void 0 : _a.type) === "optional";
  ctx.state = (_b = ctx.state) == null ? void 0 : _b.parent;
  ctx.token = void 0;
}
function isStringDelimiter(char) {
  return ["'", '"', "`"].includes(char);
}
var parseObjectLookupString_default = parseObjectLookupString;
